Paddy Rice Smart Farming

Project description
  
Rice is the staple food of the inhabitants of Sri Lanka. 
Paddy crops is cultivated as a wetland crop in all the 
districts. The total land devoted for paddy is estimated 
to be about 708,000 Hectares at present​

What led to this research ​

1.Shortage of  fertilizers.​

2.Reduction of paddy harvest. ​

3.Increase of deceases in paddy farming. ​

H.C.K De Silva
IT19237282


Abstract 

A severe drought followed by heavy rainfalls in Sri Lanka has hit large swaths 
of cropping areas, threatening the food security of some 900,000 people, according to a 
report published by the Food and Agriculture Organization of the United Nations (FAO) 
and the United Nations World Food Program (WFP).
According to the joint Crop and Food Security Assessment Mission, drought conditions 
in 2016 and early 2017 led to widespread crop failures, in particular for rice paddy - the 
country's staple food. Total paddy production in 2017 is forecast at 2.7 million tones, 
almost 40 percent less than the last year's output and 35 percent lower than the average of 
the previous five years.

The situation was exacerbated by subsequent heavy rainfalls in May. Floods and landslides 
in the south-western parts of the country caused deaths, large population displacements 
and damage to infrastructure. The rains did not ease the water supply constraints in the 
drought-impacted north-central and eastern parts of the country.

The smart farmer app proposed has the ability of determining the floods and droughts in 
Sri Lanka using machine learning techniques it includes a functionality of informing the 
farmers the likelihood of happening these disasters beforehand so that farmers can safeguard 
their stocks and take necessary actions to protect their paddy farmers.


Research Problem

Drought and flooding are two main weather calamities that can occur everywhere on the planet.
Drought is a significant cause of soil dryness in fields (causing agricultural drought), 
while floods usually bring an excessive amount of soil water; both severely limit field crop 
yields.
According to a report published by the Food and Agriculture Organization of the United 
Nations (FAO) and the United Nations World Food Program, a severe drought followed by 
torrential rains has affected large swathes of farming regions in Sri Lanka, affecting the 
food security of 900,000 people (WFP).
Drought conditions in 2016 and early 2017 caused significant crop failures, particularly 
for rice paddy, the country's staple grain, according to the joint Crop and Food Security 
Assessment Mission. In 2017, total paddy production is expected to be 2.7 million tons, 
over 40% lower than the previous year's output and 35% lower than the five-year average.
Goal of this component is to create a system that inform farmers about upcoming floods and 
droughts so they can safeguard their harvest and take necessary precautions to save their 
paddy farms.

Main Objectives

To create a system using machine learning techniques that Identify floods and droughts that 
could destroy paddy fields and inform the farmers about them.
 
Accurately predict floods that could happen in future.
Accurately predict droughts that could happen in future.
Informe the farmers about these events using an app.

A.Mathusan
IT19174822


Abstract

 
A large number of crops are grown in Sri Lanka which often serve as hosts to different kinds 
of fungi, bacteria, and virus.  some diseases reach epidemic status and cause serious crop 
losses where the impact of some is negligible [2]. Prevention and early diagnosis are 
critical to limiting damage by plant pathogens. The farmers need to monitor their crops and 
detect the first symptoms to prevent the spread of a plant disease at low cost and save a 
major part of the production. Detection of paddy leaf diseases falls important for these 
reasons.
There is a demand for research to classify paddy diseases at initial stages. 
This is feasible if there are automated systems that can assist the farmers to recognize 
the paddy diseases from the paddy leaf images of the plants. The recognition of agricultural
plant diseases by utilizing image-processing and machine learning techniques can certainly
minimize the reliance on the farmers to protect the yield of paddy crops. 
Paddy can be affected by diseases at different stages of growth and all parts of the plant. 
in order to detect and diagnose paddy leaf diseases we will be using the Image pre-processing
and segmentation technique along with different types of classification features. According 
to the implementation of the system diagnosis will be done based on periodical crop 
monitoring, images and historical information about paddy crops provided by the farmer. 
The proposed automated system can be used on android and apple platform. System can 
certainly help the farmers to classify the diseased paddy leaves at an early stage 
to protect the crops from further damage.

Research Problem

In Sri Lanka, agriculture has undergone technological transformation in the last decades, 
making farming more convenient, efficient, and profitable. However, farmers face a growing 
number of challenges and constraints that include low productivity, poor product quality, 
and climate change. 
Substantial crops are grown in Sri Lanka which often serve as hosts to different kinds of 
fungi, bacteria, and virus.  some diseases reach epidemic status and cause serious crop 
losses where the impact of some is negligible. Prevention and early diagnosis are critical 
to limiting damage by plant pathogens. The farmers need to monitor their crops and detect 
the first symptoms to prevent the spread of a plant disease at low cost and save a major 
part of the production.
They survive because of direct and indirect support from the government, such as free 
irrigation and extension services, massive fertilizer subsidies and support prices. 
The economic costs of these measures reflect the unsustainable and misdirected ways adopted 
by successive administrations. 
So, the country must continue to develop and adapt technological innovations for the 
agriculture sector to become a more productive contributor to the economy. 



Main Objectives


Predict the disease in an early stage and provide better information about the diseases. 
With this information farmers will be more aware about their crops and protect their crops 
from diseases.
Monitoring Disease – The application is capability of capturing the image of the affected 
crop and identifying the disease
Providing meaningful information – By monitoring the plant from time to time and guiding 
the users with related pesticides and level of water


S.Sivanujan
IT19149240


Abstract

 
ABSTRACT 

Agriculture is the major deciding factor of Sri Lankan economy and Paddy is the principal
crop cultivated extensively in all the districts of Sri Lanka. In Sri Lanka leads paddy 
cultivation with an area of 708,000 ha in crop yield production. Eventually, Artificial
Neural Network (ANN) techniques have emerged to be important for predicting and maximizing
the crop yield for the benefit of farmers. In previous researches they mainly focus on yield
prediction not consider wastage prediction, but in our research we mainly concentrate in paddy
wastage prediction to decrease the wastage and increase the yield in future.so we combine yield
prediction and wastage prediction with a hybrid model using Artificial Neural Network (ANN) . 
This research is based on the development of trained Neural Network models for predicting the
paddy yield and amount of wastage obtain in one harvest by varying the input parameters including
both controllable and uncontrollable factors and help farmers to find the most profitable market 
by implementing user friendly mobile application called “smart farmer”. The models have been 
experimented with different input parameters of paddy and training patterns. For this purpose,
data set  from appropriate websites were collected. The collected data were intensively studied,
the modus operando using the data was arrived at, and taken for various experiments. 
The experiments show that the trained neural network produced a minimum error which indicated
that the test model is capable of predicting and maximizing the paddy yield and minimizing the 
paddy wastage in Sri Lanka. The major objectives of this paper are to:
 (i) explore if Artificial Neural Network models with back propagation could efficiently
 predict rice yield and waste  in Sri Lankan district under various climatic conditions; 
 ground-specific rainfall, ground-specific weather variables (sunshine hours, solar radiation,
 maximum and minimum temperature, daily wind speed values) and historic yield data;
(ii) analyze the changes of model performance with variations of ANN model parameters; and 
(iii) calculate the accuracy by which paddy yield prediction is made. 

Research Problem

Traditional paddy yield methods have been used since the early twentieth century and are still in
use today but those methods are not accurate There are so many researches carried out regarding
to yield prediction using ML techniques to get maximum yield in minimum cost. These 
researches increase the yield rate by using ML. In our research we try to increase the yield
production by predicting the wastage yield that obtained in paddy harvest and try to minimize the
wastage yield in future harvest time. While predicting the wastage yield prediction here we
predict paddy yield also by combining these two prediction methods we build a hybrid prediction
model. This model will increase the rate of paddy yield by minimizing paddy wastage so we can
increase the paddy yield more than previous in all districts of Sri Lanka.



Main Objectives


This project is to predict the maximum yield of the rice produced at minimum cost and minimum
yield of paddy waste produced in every harvest. We Develop a mobile based application that can 
predict the amount of rice and waste that can be obtain in a yield using machine learning
algorithms (ANN) and automatically suggest best profitable market to sell the harvested paddy
and use the waste obtained in a harvest in co agricultural productions and predict the amount of
harvest yield annually. Consequently, it can be used in every area of the paddy sector to increase 
yield, minimize the waste production in harvest and subsequent profit of Agricultural productions.  


IT19217550
S.SriSinthujan

Abstract 

Sri Lanka is a developing country that relies heavily on 
agriculture. Agriculture, which has existed for a long time, 
however it is no longer considered efficient and sustainable 
as it used to be. However, there are disadvantages of such 
use due to the toxicity that are produced during the process. 
Several aspects of rice have been studied to increase its yield; 
however, to reduce methane emission that are produced in the 
cultivation period and regulation water supply, have not been 
studied thoroughly. In previous discussed research, they 
conducted study on how to control the amount of methane and 
how to reduce the supply of water. Therefore, there is a gap 
in knowledge, and hence the need for continuous research. 
We think smart farmer is the solution for this issue. 
Smart Farmer is a mobile application which will help to 
optimize farming process in sustainable way. This will be 
an expert system which monitor the presence of gases and 
regulating the water supply that is needed to encounter 
this problem. Big Data (BD), Machine Learning (ML) and 
Internet of Things (lot) are expected to have a large 
impact on Smart Farming and involve the whole supply 
chain, particularly for rice production. The quality of 
data collected from sensors greatly influences the performance 
of the modelling processes using ML 
algorithms. It will help to transform traditional rice 
farming practices into a new era of rice smart farming or 
rice precision agriculture. Major source of methane emissions are the 
breakdown of fertilizers and crop wastes in flooded rice 
production. However, we will face critical challenges during 
this process. We will explore how we can overcome this 
obstacle. Our proposed application, Smart Farmer is simple 
to set up and use, with a user-friendly interface and a 
powerful, consistent performance. It will help to reduce 
the emission of Methane up to 48 percentage. 


1.4 Research Problems 

Generally, the visible and invisible problems of the paddy 
rice production are unsolved in the field in the remote 
country sides. Mainly the emission of methane during the 
harvest season. There are two critical challenges are faced. 
To begin with, wetland rice is typically farmed in flooded 
areas. Moreover, during wet seasons, drainage of rice fields 
is sometimes impossible. The breakdown of fertilizers and 
crop wastages in flooded rice production is a major source 
of methane emissions. 

 

Methane is released from anaerobic wetland soils to the 
atmosphere through diffusion of dissolved methane, 
ebullition of gas bubbles, and via plants that, like rice, 
develop aerenchyma tissue. Large portions of methane formed 
in an anaerobic soil may remain trapped in the flooded soil. 
Entrapped methane may be oxidized to carbon dioxide when the 
floodwater is drained during the rice growing season or when 
the soil dries at the end of or after the rice growing season. 
But large amounts of entrapped methane may escape to the 
atmosphere immediately after the floodwater recedes. 

 

To reduce the emission, we need to act, to regulate the water 
flow. There is a need of an expert system which help to store
the daily activity and deliver it to user. Our proposed 
expert system will help user, to reduce their works by 
regulating the water supply. In result, Methane emission 
will reduce up to 48% and we can reduce the wastage of water.   


Main Objectives 

Identify the Level of Methane gas and improve the farm environmental factors using ML 

Specific Objectives 

Detect the conditions 

Regulate the water supply according to environmental conditions 

Activate alarm system in case of danger 

 
